//+------------------------------------------------------------------+
//|                                                 MTF_MFI.mq4      |
//|                                       http://www.metaquotes.net/ |
//|                                            www.forex-tsd.com     |                                     |
//+------------------------------------------------------------------+
#property copyright "Copyright  www.metaquotes.net"
#property link      "http://www.forex-tsd.com"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_level1 20
#property indicator_level2 50
#property indicator_level3 80
#property indicator_levelcolor SlateGray
#property indicator_buffers 2
#property indicator_color1 DarkViolet
#property indicator_color2 DarkSlateBlue


//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
---------------------------------------
MODE_SMA    0 Simple moving average, 
MODE_EMA    1 Exponential moving average, 
MODE_SMMA   2 Smoothed moving average, 
MODE_LWMA   3 Linear weighted moving average. 
You must use the numeric value of the MA Method that you want to use
when you set the 'ma_method' value with the indicator inputs.

**************************************************************************/
extern int TimeFrame=0;
extern int ExtMFIPeriod1=14;
extern int ExtMFIPeriod2=28;

double ExtMapBuffer1[];
double ExtMapBuffer2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   
//---- indicator line
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexLabel(0,"MTF_MFI("+ExtMFIPeriod1+")");
   SetIndexLabel(1,"MTF_MFI("+ExtMFIPeriod2+")");
   if (TimeFrame<Period()) TimeFrame=Period();
   
//---- name for DataWindow and indicator subwindow label   
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="M5"; break;
      case 15 : TimeFrameStr="M15"; break;
      case 30 : TimeFrameStr="M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="H4"; break;
      case 1440 : TimeFrameStr="D1"; break;
      case 10080 : TimeFrameStr="W1"; break;
      case 43200 : TimeFrameStr="MN"; break;
      default : TimeFrameStr="TF0";
   } 
   IndicatorShortName("MTF_MFI("+ExtMFIPeriod1+","+ExtMFIPeriod2+")TF"+TimeFrame+" ");  
  }
//----
   return(0);
 
//+------------------------------------------------------------------+
//| MTF                                                   |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i,shift,limit,y=0,counted_bars=IndicatorCounted();
    
// Plot defined timeframe on to current timeframe   
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit=Bars-counted_bars-1+TimeFrame/Period();
   for(i=0,y=0;i<limit;i++)
   {
     if (Time[i]<TimeArray[y]) y++; 
   
 /***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator timeframe
   Rule 3:  Use 'y' for the indicator's shift value
 **********************************************************/  
     
   ExtMapBuffer1[i]=iMFI(NULL,TimeFrame, ExtMFIPeriod1,y);
   ExtMapBuffer2[i]=iMFI(NULL,TimeFrame, ExtMFIPeriod2,y);
     
   }  
     
 
  
   return(0);
  }
//+------------------------------------------------------------------+